"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.withEmotion = void 0;
const document_1 = __importDefault(require("next/document"));
const react_1 = __importDefault(require("react"));
const server_1 = require("@emotion/server");
const withEmotion = () => TargetComponent => class WithEmotion extends TargetComponent {
    static getInitialProps(context) {
        const _super = Object.create(null, {
            getInitialProps: { get: () => super.getInitialProps }
        });
        return __awaiter(this, void 0, void 0, function* () {
            const props = yield _super.getInitialProps.call(this, context);
            const { css, ids } = server_1.extractCritical(props.html);
            props.styles.push(react_1.default.createElement("style", { key: 'emotion', dangerouslySetInnerHTML: { __html: css } }));
            return Object.assign(Object.assign({}, props), { ids });
        });
    }
    static renderDocument(...args) {
        return document_1.default.renderDocument(...args);
    }
    constructor(props) {
        super(props);
        const { __NEXT_DATA__, ids } = props;
        if (ids) {
            __NEXT_DATA__.ids = ids;
        }
    }
};
exports.withEmotion = withEmotion;
